function f=fcn(par,data)
% big common fcn
% inherits globals 
%    MU_COMPONENT with list of all model components
%    znmodel with selected model
%    zn_gamu, zn_alpha (constants)
%    zn_t time bin centers, row vector

% ROUGH DESCRIPTION
%            arrange parameters 
%            calculate contributions
%            and add corrections (e.g. dalpha)

global MU_COMPONENT MU_MODEL MU_TABLE


cn=MU_MODEL.COMPONENTNUMBER; % number of components
f=zeros(0,size(data(1,:),2)); % start with zero f 
for k=1:cn
    kk=find(strcmp(MU_COMPONENT.NAME,MU_MODEL.COMPONENT(k).NAME));
    % order number of model component k in the MU_COMPONENT list
    p=par(MU_MODEL.COMPONENT(k).SHARE); % p is a version of
    %    par with duplicated values for '=' parameters
    %disp(char(MU_COMPONENT.DEFINITION(kk)))
    eval(['f=[f; ' char(MU_COMPONENT.DEFINITION(kk)) '];'])
    % computes function from definition
    % adding each component as a new row;
    % pdf (polarization function) at center of time bin, data(:,1), 
    % or, ideally, (cdf(data(1,:)+dt/2)-cdf(data(1,:)-dt/2))/dt, where 
    % cdf is integral of pdf and dt is time bin width
end

% uncorrected sum
f=sum(f,1); % sum along columns (components), calculates function

% correction factors (like 'da')

kda=find(strcmp(cellstr(strvcat(MU_MODEL.COMPONENT.NAME)),'da'));
% is 'da' one of the ingredients? 
% if it exists kda is the order of the 'da' component in MU_MODEL
if ~isempty(kda)    
    dalpha=par(MU_MODEL.COMPONENT(kda).SHARE);
    dadalpha=dalpha/MU_MODEL.ALPHA;
    f=((2.d0+dadalpha)*f-dadalpha)./...
      ((2.d0+dadalpha)-dadalpha*f); 
end

if (size(data,1)>2), % error = 3rd row of data
  f = sum(((data(2,:) - f)./data(3,:)).^2);
end
