function mueditmodel(varargin)
%
% usage mumodeledit
%
% offers to Append, Delete, Replace a component or to Erase the model
global MU_MODEL MU_COMPONENT MU_FIG
if isfield(MU_MODEL,'NAME')
    options={'Append components' 'Delete component' ...
             'Replace component' 'Erase model'};

    if isempty(varargin)
        mumodellist;
        command=mutxtmenu(options);
    else
        [command ok]=listdlg('PromptString','Select an option',...
                'SelectionMode','single',...
                'ListString',options,'Name','Edit present model');
        if ok
            
            command=char(options(command));
            command=upper(command(1));
        else
            command='';
        end
    end

    if ~isempty(command)
        switch command
          case 'A'
            if isempty(varargin) % command driven
                mulistcomponents;
                components=input(['    Select components to add from ' ...
                              'the list (e.g. bamu) '],'s');
            else % gui

                options=MU_COMPONENT.NAME;
                [components ok]=listdlg('PromptString','Add a component',...
                                     'SelectionMode','single',...
                                     'ListString',options,'Name',['Edit ' ...
                                    'present model']);
                components=char(options(components));
                if ~ok
                    components='';
                end
            end
            
            n=mugetcomponent(components); % n is the order in MU_COMPONENT
            new=length(n); % number of new components
            old=MU_MODEL.COMPONENTNUMBER; % number of old components
            par=mucountpar; % number of parameters in old model
            knew=0;
            MU_MODEL.COMPONENTNUMBER=old+new; 
            MU_MODEL.NAME=[MU_MODEL.NAME components]; %append new names
            for k=old+1:old+new
                knew=knew+1; 
                MU_MODEL.COMPONENT(k).NAME=char(MU_COMPONENT.NAME(n(knew)));
                MU_MODEL.COMPONENT(k).PARAMETERNUMBER=...
                    MU_COMPONENT.PARAMETER(n(knew)).NUMBER;
                MU_MODEL.COMPONENT(k).SHARE=par+...
                    [1:MU_MODEL.COMPONENT(k).PARAMETERNUMBER];
                par=par+MU_MODEL.COMPONENT(k).PARAMETERNUMBER;
                pname=MU_COMPONENT.PARAMETER(n(knew)).NAME;
                for j=1:MU_MODEL.COMPONENT(k).PARAMETERNUMBER
                    MU_MODEL.COMPONENT(k).PARAMETER(j).NAME=...
                        char(pname(j));
                    MU_MODEL.COMPONENT(k).PARAMETER(j).VALUE=0;
                    MU_MODEL.COMPONENT(k).PARAMETER(j).FLAG='~';
                end
            end
            MU_MODEL.NRUN=[];
            if isempty(varargin) 
                mumodel
            elseif new
                close(MU_FIG.MENU)
                mufit_gui  % force layout
            end
          
          case 'D'
            % [n l name]=mumodellist;
            if isempty(varargin) % command driven
                delete=input('Enter number of component to be deleted: ');
            else % gui

                options={MU_MODEL.COMPONENT.NAME};
                [delete ok]=listdlg('PromptString','Delete a component',...
                                     'SelectionMode','single',...
                                     'ListString',options,'Name',['Edit ' ...
                                    'present model']);
                if ~ok
                    delete='';
                end
            end
            if ~isempty(delete)
                temp=MU_MODEL;
                clear global MU_MODEL
                global MU_MODEL
                if delete==1
                    newname=temp.NAME(3:end);
                elseif delete==temp.COMPONENTNUMBER;
                    newname=temp.NAME(1:end-2);
                else
                    newname=temp.NAME([1:2*(delete-1) 2*(delete+1)-1:end]);
                end
                MU_MODEL.NAME=newname;
                MU_MODEL.COMPONENTNUMBER=temp.COMPONENTNUMBER-1;
                MU_MODEL.ALPHA=temp.ALPHA;
                MU_MODEL.FLAG.TYPE=temp.FLAG.TYPE;
                MU_MODEL.FLAG.DENOMINATOR=temp.FLAG.DENOMINATOR;
                MU_MODEL.BATCHMODE=temp.BATCHMODE;
                MU_MODEL.GROUPING(1).FORWARD=temp.GROUPING(1).FORWARD;
                MU_MODEL.GROUPING(1).BACKWARD=temp.GROUPING(1).BACKWARD;
                MU_MODEL.RANGE=temp.RANGE;
                MU_MODEL.BIN=temp.BIN;
                par=0;
                for k=1:delete-1;
                    MU_MODEL.COMPONENT(k).NAME=temp.COMPONENT(k).NAME;
                    MU_MODEL.COMPONENT(k).PARAMETERNUMBER=...
                        temp.COMPONENT(k).PARAMETERNUMBER;
                    MU_MODEL.COMPONENT(k).SHARE=temp.COMPONENT(k).SHARE;
                    par=par+MU_MODEL.COMPONENT(k).PARAMETERNUMBER;
                    for j=1:MU_MODEL.COMPONENT(k).PARAMETERNUMBER
                        MU_MODEL.COMPONENT(k).PARAMETER(j).NAME=...
                            temp.COMPONENT(k).PARAMETER(j).NAME;
                        MU_MODEL.COMPONENT(k).PARAMETER(j).VALUE=...
                            temp.COMPONENT(k).PARAMETER(j).VALUE;
                        MU_MODEL.COMPONENT(k).PARAMETER(j).FLAG=...
                            temp.COMPONENT(k).PARAMETER(j).FLAG;
                    end
                end 
                kk=delete-1;
                for k=delete+1:temp.COMPONENTNUMBER
                    kk=kk+1;
                    MU_MODEL.COMPONENT(kk).NAME=temp.COMPONENT(k).NAME;
                    MU_MODEL.COMPONENT(kk).PARAMETERNUMBER=...
                        temp.COMPONENT(k).PARAMETERNUMBER;
                    MU_MODEL.COMPONENT(kk).SHARE=par+...
                        [1:MU_MODEL.COMPONENT(kk).PARAMETERNUMBER];
                    par=par+MU_MODEL.COMPONENT(kk).PARAMETERNUMBER;
                    for j=1:MU_MODEL.COMPONENT(kk).PARAMETERNUMBER
                        MU_MODEL.COMPONENT(kk).PARAMETER(j).NAME=...
                            temp.COMPONENT(k).PARAMETER(j).NAME;
                        MU_MODEL.COMPONENT(kk).PARAMETER(j).VALUE=...
                            temp.COMPONENT(k).PARAMETER(j).VALUE;
                        MU_MODEL.COMPONENT(kk).PARAMETER(j).FLAG=...
                            temp.COMPONENT(k).PARAMETER(j).FLAG;
                    end
                end                                
                if ~isempty(varargin)
                    close(MU_FIG.MENU)
                    mufit_gui  % force layout
                end
            end
          case 'R'
            if isempty(varargin) % command driven
                replace=input('Enter number of component to be replaced: ');
            else % gui

                options={MU_MODEL.COMPONENT.NAME};
                [replace ok]=listdlg('PromptString','Replace a component',...
                                     'SelectionMode','single',...
                                     'ListString',options,'Name',['Edit ' ...
                                    'present model']);
                if ~ok
                    replace='';
                end
            end

            if ~isempty(replace)
                if isempty(varargin) % command driven
                    mulistcomponents;
                    ok=0;
                    while ~ok
                        component=input('Enter name of new component : ','s');
                        with=mugetcomponent(component); % number in
                                                        % MU_COMPONENT
                        ok=(length(with)==1); % if answer is not one
                                              % valid component reask
                    end
                else % gui
                    options=MU_COMPONENT.NAME;
                    [with ok]=listdlg('PromptString',...
                                      'Replace a component',...
                                      'SelectionMode','single',...
                                      'ListString',options,...
                                      'Name',['Edit present model']);
                    if ~ok
                        with=replace;
                    end
                    component=char(MU_COMPONENT.NAME(with));
                end
                temp=MU_MODEL;
                clear global MU_MODEL
                global MU_MODEL
                MU_MODEL.NAME=temp.NAME;
                MU_MODEL.NAME(2*replace-1:2*replace)=component;
                MU_MODEL.COMPONENTNUMBER=temp.COMPONENTNUMBER;
                MU_MODEL.ALPHA=temp.ALPHA;
                MU_MODEL.FLAG.TYPE=temp.FLAG.TYPE;
                MU_MODEL.FLAG.DENOMINATOR=temp.FLAG.DENOMINATOR;
                MU_MODEL.BATCHMODE=temp.BATCHMODE;
                MU_MODEL.GROUPING(1).FORWARD=temp.GROUPING(1).FORWARD;
                MU_MODEL.GROUPING(1).BACKWARD=temp.GROUPING(1).BACKWARD;
                MU_MODEL.RANGE=temp.RANGE;
                MU_MODEL.BIN=temp.BIN;
                par=0;
                % notice: replace is the index referred to MU_MODEL
                %         with is the index referred to MU_COMPONENT
                for k=1:replace-1;
                    MU_MODEL.COMPONENT(k).NAME=temp.COMPONENT(k).NAME;
                    MU_MODEL.COMPONENT(k).PARAMETERNUMBER=...
                        temp.COMPONENT(k).PARAMETERNUMBER;
                    MU_MODEL.COMPONENT(k).SHARE=temp.COMPONENT(k).SHARE;
                    par=par+MU_MODEL.COMPONENT(k).PARAMETERNUMBER;
                    for j=1:MU_MODEL.COMPONENT(k).PARAMETERNUMBER
                        MU_MODEL.COMPONENT(k).PARAMETER(j).NAME=...
                            temp.COMPONENT(k).PARAMETER(j).NAME;
                        MU_MODEL.COMPONENT(k).PARAMETER(j).VALUE=...
                            temp.COMPONENT(k).PARAMETER(j).VALUE;
                        MU_MODEL.COMPONENT(k).PARAMETER(j).FLAG=...
                            temp.COMPONENT(k).PARAMETER(j).FLAG;
                    end
                end                
                MU_MODEL.COMPONENT(replace).NAME=component;
                pnum=MU_COMPONENT.PARAMETER(with).NUMBER;
                MU_MODEL.COMPONENT(replace).PARAMETERNUMBER=pnum;
                pname=MU_COMPONENT.PARAMETER(with).NAME;
                MU_MODEL.COMPONENT(replace).SHARE=par+[1:pnum]; % index in p
                par=par+pnum;
                for j=1:pnum
                    MU_MODEL.COMPONENT(replace).PARAMETER(j).NAME=...
                        char(pname(j));
                    MU_MODEL.COMPONENT(replace).PARAMETER(j).VALUE=0;
                    MU_MODEL.COMPONENT(replace).PARAMETER(j).FLAG='~';
                end
                for k=replace+1:MU_MODEL.COMPONENTNUMBER
                    MU_MODEL.COMPONENT(k).NAME=temp.COMPONENT(k).NAME;
                    MU_MODEL.COMPONENT(k).PARAMETERNUMBER=...
                        temp.COMPONENT(k).PARAMETERNUMBER;
                    MU_MODEL.COMPONENT(k).SHARE=par+...
                        [1:MU_MODEL.COMPONENT(k).PARAMETERNUMBER];
                    par=par+MU_MODEL.COMPONENT(k).PARAMETERNUMBER;
                    for j=1:MU_MODEL.COMPONENT(k).PARAMETERNUMBER
                        MU_MODEL.COMPONENT(k).PARAMETER(j).NAME=...
                            temp.COMPONENT(k).PARAMETER(j).NAME;
                        MU_MODEL.COMPONENT(k).PARAMETER(j).VALUE=...
                            temp.COMPONENT(k).PARAMETER(j).VALUE;
                        MU_MODEL.COMPONENT(k).PARAMETER(j).FLAG=...
                            temp.COMPONENT(k).PARAMETER(j).FLAG;
                    end
                end                
            end
            if isempty(varargin)
                mumodel
            else
                close(MU_FIG.MENU)
                mufit_gui  % force layout
            end
              
          case 'E'
            if isempty(varargin) % command driven
                s=input('Erase model. Are you sure? [Y] ','s');
                s=upper(s);
            else % gui
                s=questdlg('Erasing model: are you sure?','Title',['Edit ' ...
                                    'present model'],'Default','Yes');
                if ~ok
                    s='N';
                else
                    s=char(s);
                    s=s(1);
                end
            end
            if isempty(s)|(s=='Y')
                clear global MU_MODEL
            end
            if isempty(varargin)
                disp(['Use mumodel to either load a saved model '...
                      'or to create one from scratch'])
            else
                close(MU_FIG.MENU)
                mufit_gui  % force layout
            end
        end
    end
end