function OK=muextractflag(answer,par)
% par is the index in the parameter menu list 
%    i.e. the progressive number in MU_MODEL
% answer is the string from mufit_gui parameter menu, 
%
% parses the string 
% saves it in MU_MODEL.COMPONENT(c).PARAMETER(p).FLAG 
% and in MU_MODEL.SHARE
% or in  MU_MODEL.COMPONENT(c).PARAMETER(p).LINREL 
% if syntax is correct (OK=1)
% does nothing otherwiseleaves old value otherwise (OK=0)

global MU_MODEL

% parsing the answer
% what to do if an answer is illegal? 
% put back old value

OK=1; % set default RIGHT
[string c p]=mucomp(par);

% cases               1    2    3   
% answer may be e.g , ~, =5, +p(3)*0.2+p(1)
% linrel (+) policy:
% put parameter index in MU_MODEL.COMPONENT(c).PARAMETER(p).SHARE
% share (=) policy:
% put shared parameter index in
% MU_MODEL.COMPONENT(c).PARAMETER(p).SHARE
% mufit takes care of creating the right MU_MODEL.SHARE, which sets
% the rule for fcn 

oldflag=MU_MODEL.COMPONENT(c).PARAMETER(p).FLAG;
if isfield(MU_MODEL.COMPONENT(c).PARAMETER(p),'LINREL')
    oldlinrel=MU_MODEL.COMPONENT(c).PARAMETER(p).LINREL;
end

    
switch answer(end)
  case {'~','!'}
    if answer(end)~=oldflag
        MU_MODEL.COMPONENT(c).PARAMETER(p).FLAG=answer(end);
                  MU_MODEL.COMPONENT(c).PARAMETER(p).SHARE=par;
        % share(par) contains the index of this active parameter,
        % will be recalculated in mufit
        % before launching fminuit  
    end
  case {'=','+'} % '=','+' at the end, confirms a previous setting
    if answer(end)~=oldflag
        string=strvcat('Flag has changed', ...
                       ['Missing information: '  answer])
             msgbox(string,...
                    'Parameter flag',...
                    'non-modal')
             OK=0; % a changed = requires a number (shared par)
                   % a changed + requires a linear relation 
    end
  otherwise  % a share or a linrel
    switch answer(1)
      case '=' % followed by a number: setting a new share
        answer0=answer(2:end); % this should be the shared par
        [sharepar isnum]=str2num(answer0);
        if isnum&&sharepar<par
            % if ~isnum means that answer is not a number
            MU_MODEL.COMPONENT(c).PARAMETER(p).FLAG='=';
            MU_MODEL.COMPONENT(c).PARAMETER(p).SHARE=sharepar;
            % share(par) contains the index of this active parameter,
            % will be recalculated in mufit
            % before launching fminuit 
        else
            string=strvcat(['n=' num2str(par) ...
                            ' must be shared with m<n'], ...
                            ['You typed "'  answer '"'])
             msgbox(string,...
                    'Parameter flag',...
                    'non-modal')
            OK=0;
        end
      case '+' % followed by a linear relation
        OK=muparse(answer(2:end));
        if OK  
            MU_MODEL.COMPONENT(c).PARAMETER(p).LINREL=...
                answer(2:end);
            MU_MODEL.COMPONENT(c).PARAMETER(p).FLAG='+';
            MU_MODEL.COMPONENT(c).PARAMETER(p).SHARE=par;
            % share(par) contains the index of this active parameter,
            % will be recalculated in mufit
            % before launching fminuit  
        else
            string=strvcat('Incorrect linear relation: ', ...
                           ['"'  answer '"'])
            msgbox(string,...
                    'Parameter flag',...
                    'non-modal')
        end
    end
end
