function OK=muextractparameters(answer)
% invoked by mumodeldisplay
% scans parameters 
% identifying them by their number in the fminuit list
% unwraps answer from inputdlg
global MU_MODEL

    % e.g. damu
parpercomp=cell2mat({MU_MODEL.COMPONENT.PARAMETERNUMBER}); % e.g. 1 5
ptot=sum(parpercomp);% e.g. 6

% parsing the answer
% what to do if an answer is illegal? 
% issue a warning and leave as is
OK=1; % set RIGHT
par=0;
for n=1:ptot
    [string c p]=mucomp(n);
    answer0=deblank(char(answer(n)));
% cases              1    2    3   4   5
% answer may be e.g 0.2, 0.2!, ~, =5, +p(3)*0.2+p(1)
    if ~isempty(answer0)
      
      switch answer0(end)
        case {'~','!'}
          par=par+1;
          MU_MODEL.COMPONENT(c).PARAMETER(p).FLAG=answer0(end);
          answer0=answer0(1:end-1);          
          switch MU_MODEL.COMPONENT(c).PARAMETER(p).FLAG
            case '+'
              if answer0(end)~='+' % was +, not anymore
                  MU_MODEL.COMPONENT(c).PARAMETER(p).LINREL='';
              end
            case '='
              if answer0(end)~='=' % was =, not anymore
                  MU_MODEL.COMPONENT(c).SHARE=[share(1:p-1) par ...
                                      share(p+1:end)];
              end
          end   
        case {'=','+'} % '=','+' at the end, confirms a previous setting
          answer0=[]; % nothing to do 
        otherwise  % a number, a share or a linrel
          switch answer0(1)
            case '=' % followed by a number: setting a new share
              answer0=answer0(2:end); % this should be the shared par
              [sharepar isnum]=str2num(answer0);
              if isnum % if ~isnum means that answer0 is not a number
                  MU_MODEL.COMPONENT(c).PARAMETER(p).FLAG='=';
                  share=MU_MODEL.COMPONENT(c).SHARE;
                  MU_MODEL.COMPONENT(c).SHARE=[share(1:p-1) sharepar ...
                                      share(p+1:end)];
                  [dum cc pp]=mucomp(sharepar);
                  MU_MODEL.COMPONENT(c).PARAMETER(p).VALUE=...
                      MU_MODEL.COMPONENT(cc).PARAMETER(pp).VALUE;
                  answer0=[];
              else
                  disp(['Par ' num2str(n) ': =' answer0 ' wrong ' ...
                        'syntax'])
                  OK=0;
              end
            case '+' % followed by a linear relation
              OK=muparse(answer0(2:end));
              if OK  
                  MU_MODEL.COMPONENT(c).PARAMETER(p).LINREL=answer0(2:end);
                  MU_MODEL.COMPONENT(c).PARAMETER(p).FLAG='+';
                  share=MU_MODEL.COMPONENT(c).SHARE;
                  MU_MODEL.COMPONENT(c).SHARE=[share(1:p-1) par ...
                                      share(p+1:end)];
                  answer0=[];
              else
                  disp(['Par ' num2str(n) ': ' answer0 ' wrong ' ...
                        'syntax'])
              end
            otherwise % a number (will be read below), increas par if fix=~!
              flag=MU_MODEL.COMPONENT(c).PARAMETER(p).FLAG;
              if flag=='~'|flag=='!'
                  par=par+1
              end
          end
      end

    else % empty value, leave unchanged and increas par if fix=~!
        flag=MU_MODEL.COMPONENT(c).PARAMETER(p).FLAG;
        if flag=='~'|flag=='!'
              par=par+1
        end
    end
    l=length(answer0);
    ok=0; % not ok
    if l % there is a new possible value
        while ~ok
            a=uint8(answer0(l));
            if (a>=48&a<=57)|a==46 % last character is a number or
                                   % a '.'
                [v OOK]=str2num(answer0); % try and read it
                if ~OOK % not a valid number
                    disp(['Par ' num2str(n) ': ' char(answer(n)) ...
                          ' wrong syntax'])
                    OK=0; % at least one wrong value
                end
                  ok=1;
                  % elseif l>1; % if last char not a number and there are more 
                  % l=l-1;  % try one less
                  % answer0=answer0(1:end-1); 
            else
                disp(['Par ' num2str(n) ': ' char(answer(n)) ...
                      ' wrong syntax'])
                ok=1; % was last character and a number was not
                      % read.
                OOK=0;
                OK=0; % at least one wrong value
            end
            if OOK % register the new value 
                MU_MODEL.COMPONENT(c).PARAMETER(p).VALUE=v;
            end
        end
    end
end

