function mumodel(varargin)
% usage mumodel('damu')
%
% creates a model made by several components 
% parsing the name (e.g. damu) and loking for components
% from the list defined in initialize_zn_components 
% (see mu...)
%
% usage mumodel
%
% to edit model, if it exists, or else to load one
%
% See also MUPATH, MULOAD, MUSET, MUMODEL, MUFITMENU, MUFIT,
% MUSAVEMODEL, MURIG, MULABSAVE, MULIST, MUPLOT
%
% HELP MU for a list,  

global MU_MODEL

if isempty(varargin)
    if isfield(MU_MODEL,'ALPHA') % old model exists
        mumodeldisplay % then edit it
    else % does not exist
        disp('Model does not exist, load one?') 
        muldmodel %propose to load a model
    end
else % call with argument of type 'damu', create model
    if size(varargin)==[1 1]
        mucreatemodel(varargin)
    else
        disp('mumodel, too many arguments!')
    end
end
