function mupath(datadir,logdir)
% usage mupath(datadir,logdir)
%
% Normally needed when analysing a new sample, 
% i.e. selecting a new data directory.
%
% Datadir must be an existing directory, possibly containing data
% Logdir may be either a valid directory or a keyword: 
% e.g datadir='/home/musr/psi/run_10_08/gps/mysample/'
% then logdir='psi' generates
% logdir='/home/user/psi/run_10_08/gps/mysample/'
%
% If MU_PATH exists, mupath 
% replaces MU_PATH.LOG with logdir and MU_PATH.DATA with datadir,
% If MU_PATH does not exist, mupath defines the 
% global structure MU_PATH,fills its fields LOG and DATA, and then 
% it performs addpath(MU_PATH.LOG)

global MU_PATH

if exist(datadir)==7
    if datadir(end)~='/'
        datadir=[datadir '/'];
    end
    MU_PATH.DATA=datadir;
    if exist(logdir)==7
     if logdir(end)~='/'
        logdir=[datadir '/'];
    end
       MU_PATH.LOG=logdir;
        string=strvcat(['Datadr: ' char(MU_PATH.DATA)],...
                       ['Logdir: ' char(MU_PATH.LOG)]);
        disp(string)
    else
        i1=strfind(datadir,logdir)...
           +length(logdir); % beginning of part to be copied
        [d user]=unix('echo $USER');
        newpath=datadir(i1:end);
        %            logdir=strcat('/home/',user,'/',logdir,newpath);
        if newpath(end)~='/'
            newpath(end+1)='/';
        end
        i2=strfind(newpath,'/');
        d=strcat('/home/',user,'/',logdir);
        a=0;
        for k=1:length(i2)-1
            d=strcat(d,newpath(i2(k):i2(k+1)-1));
            if exist(d)~=7
                a=unix(['mkdir ' d]);
                if a~=0
                    disp(['directory ' d ' cannot be created'])
                end
            end
        end
        logdir=d;
        if a==0
            MU_PATH.LOG=logdir;
            string=strvcat(['Datadr: ' char(MU_PATH.DATA)],...
                           ['Logdir: ' char(MU_PATH.LOG)]);
            disp(string)
        else
            disp('**** Warning: logdir not set! ****')
        end
    end
else
    eval(['dir ' datadir])
end