function murig
% usage murig
%
% OLD COMMAND LINE ROUTINE
% generates only the following global structure
% MU_GEAR, with fields FACILITY, INSTRUMENT, DATA_TYPE, 
% FILENAME_PREFIX, FILENAME_SUFFIX
%
% Run mulabsave if you want to save this into MULAB.mat.
% In this version OFFSET is fixed at 7 bins after t=0.
% (Best rethink)
% 
% See also MUPATH, MULOAD, MUSET, MUMODEL, MUFITMENU, MUFIT,
% MUSAVEMODEL, MURIG, MULABSAVE, MULIST, MUPLOT
%
% HELP MU for a list,  
    

    global MU_GEAR
    nok=1;  
    while nok
        fac=input(['Which facility (PSI, ISIS)? [' ...
                   MU_GEAR.FACILITY '] '],'s');
        if ~isempty(fac)
            fac=upper(fac);
        else
            fac=MU_GEAR.FACILITY;
        end
        switch fac
          case {'P','PS','PSI'}
            MU_GEAR.FACILITY='PSI';
            nok=0;
            nnok=1;
            while nnok
                fac=input(['Which instrument (GPS,LTF,DOLLY)? [' ...
                            MU_GEAR.INSTRUMENT '] '  ],'s');
                if ~isempty(fac)
                    fac=upper(fac);
                else
                    fac=MU_GEAR.INSTRUMENT;
                end
                switch fac
                  case {'G','GP','GPS'}
                    MU_GEAR.INSTRUMENT='GPS';
                    nnok=0;
                    s=input('Filename prefix [gps] ','s');
                    if isempty(s)
                        MU_GEAR.FILENAME_PREFIX='gps';
                    else
                        MU_GEAR.FILENAME_PREFIX=s;
                    end
                    MU_GEAR.OFFSET=7;
                  case {'L','LT','LTF'}
                    MU_GEAR.INSTRUMENT='EMU';
                    nnok=0;
                    s=input('Filename prefix [ltf] ','s');
                    if isempty(s)
                        MU_GEAR.FILENAME_PREFIX='ltf';
                    else
                        MU_GEAR.FILENAME_PREFIX=s;
                    end
                    MU_GEAR.OFFSET=10;
                  case {'D','DO','DOL','DOLL','DOLLY'}
                    MU_GEAR.INSTRUMENT='DOLLY';
                    nnok=0;                        
                    s=input('Filename prefix [dol] ','s');
                    if isempty(s)
                        MU_GEAR.FILENAME_PREFIX='dol';
                    else
                        MU_GEAR.FILENAME_PREFIX=s;
                    end
                    MU_GEAR.OFFSET=10;
                  otherwise
                    disp([fac '? Not clear, retry.'])
                end
            end
            nnok=1;
            while nnok
                fac=input(['Which data type (ASCII, BIN)? ['...
                          MU_GEAR.DATA_TYPE '] '],'s');
                if ~isempty(fac)
                    fac=upper(fac);
                else
                    fac=MU_GEAR.DATA_TYPE;
                end
                switch fac
                  case {'A','AS','ASC','ASCI','ASCII'}
                    MU_GEAR.DATA_TYPE='ASCII';
                    nnok=0;
                    s=input('Filename suffix [dat] ','s');
                    if isempty(s)
                        MU_GEAR.FILENAME_SUFFIX='dat';
                    else
                        MU_GEAR.FILENAME_SUFFIX=s;
                    end
                  case {'B','BI','BIN'}
                    MU_GEAR.DATA_TYPE='BIN';
                    nnok=0;
                    s=input('Filename suffix [bin] ','s');
                    if isempty(s)
                        MU_GEAR.FILENAME_SUFFIX='bin';
                    else
                        MU_GEAR.FILENAME_SUFFIX=s;
                    end
                  otherwise
                    disp([fac '? Not clear, retry.'])
                end
                MU_GEAR.OFFSET=7; % from prompt to first good
            end
          case {'I','IS','ISI','ISIS'}
            MU_GEAR.FACILITY='ISIS';
            nok=0;
            nnok=1;
                while nnok
                    fac=input(['Which instrument (MUS,EMU,HIF)? ['...
                              MU_GEAR.INSTRUMENT '] '],'s');
                    fac=upper(fac);
                    switch fac
                      case {'M','MU','MUS','MUSR'}
                        MU_GEAR.INSTRUMENT='MUS';
                        nnok=0;
                        s=input('Filename prefix [mus] ','s');
                        if isempty(s)
                            MU_GEAR.FILENAME_PREFIX='mus';
                        else
                            MU_GEAR.FILENAME_PREFIX=s;
                        end
                        MU_GEAR.OFFSET=7; % from prompt to first good
                      case {'E','EM','EMU'}
                        MU_GEAR.INSTRUMENT='EMU';
                        nnok=0;
                        s=input('Filename prefix [emu] ','s');
                        if isempty(s)
                            MU_GEAR.FILENAME_PREFIX='emu';
                        else
                            MU_GEAR.FILENAME_PREFIX=s;
                        end
                      MU_GEAR.OFFSET=7; % from prompt to first good
                      case {'H','HI','HIF'}
                        MU_GEAR.INSTRUMENT='HIF';
                        nnok=0;                        
                        s=input('Filename prefix [hif] ','s');
                        if isempty(s)
                            MU_GEAR.FILENAME_PREFIX='hif';
                        else
                            MU_GEAR.FILENAME_PREFIX=s;
                        end
                      MU_GEAR.OFFSET=7; % from prompt to first good
                      otherwise
                        disp([fac '? Not clear, retry.'])
                    end
                end
                nnok=1;
                while nnok
                    fac=input('Which data type (MCS,NEXUS)? ','s');
                    fac=upper(fac);
                    switch fac
                      case {'M','MC','MCS'}
                        MU_GEAR.DATA_TYPE='MCS';
                        nnok=0;
                        s=input('Filename suffix [raw] ','s');
                        if isempty(s)
                            MU_GEAR.FILENAME_SUFFIX='raw';
                        else
                            MU_GEAR.FILENAME_SUFFIX=s;
                        end
                     case {'N','NE','NEX','NEXU','NEXUS','NXS'}
                        MU_GEAR.DATA_TYPE='NEXUS';
                        nnok=0;
                        s=input('Filename suffix [nxs] ','s');
                        if isempty(s)
                            MU_GEAR.FILENAME_SUFFIX='nxs';
                        else
                            MU_GEAR.FILENAME_SUFFIX=s;
                        end
                      otherwise
                        disp([fac '? Not clear, retry.'])
                    end
                end
               otherwise
                disp([fac '? Not clear, retry.'])
            end
        end
        

